
class UnitConverter(object):
    def __init__(self):
        pass

    def base_unit_value_from_value(self, value):
        return value

    def value_from_base_unit_value(self, value):
        return value


class UnitConverterLinear(UnitConverter):
    def __init__(self, coefficient, constant=0.0):
        super(UnitConverterLinear, self).__init__()

        self.coefficient = coefficient
        self.constant = constant

    def __eq__(self, other):
        return self.coefficient == other.coefficient and self.constant == other.constant

    def base_unit_value_from_value(self, value):
        return value * self.coefficient + self.constant

    def value_from_base_unit_value(self, value):
        return (value - self.constant) / self.coefficient


class UnitConverterReciprocal(UnitConverter):
    def __init__(self, reciprocal):
        super(UnitConverterReciprocal, self).__init__()
        self.reciprocal = reciprocal

    def __eq__(self, other):
        return self.reciprocal == other.reciprocal

    def base_unit_value_from_value(self, value):
        return self.reciprocal / value

    def value_from_base_unit_value(self, value):
        return self.reciprocal / value
