# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Acceleration(Unit):
    def __init__(self, symbol, coefficient):
        super(Acceleration, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Acceleration'

    @classmethod
    def base_unit(cls):
        return cls.meters_per_second_squared

    @classproperty
    def meters_per_second_squared(cls):
        return Acceleration('m/s²', 1.0)

    @classproperty
    def gravity(cls):
        return Acceleration('g', 9.81)
