# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty
import math


class Angle(Unit):
    def __init__(self, symbol, coefficient):
        super(Angle, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Angle'

    @classmethod
    def base_unit(cls):
        return cls.degrees

    @classproperty
    def degrees(cls):
        return Angle('°', 1.0)

    @classproperty
    def arcMinutes(cls):
        return Angle('ʹ', 1.0 / 60.0)

    @classproperty
    def arcSeconds(cls):
        return Angle('ʹʹ', 1.0 / 3600.0)

    @classproperty
    def radians(cls):
        return Angle('rad', 180.0 / math.pi)

    @classproperty
    def gradians(cls):
        return Angle('grad', 0.9)

    @classproperty
    def revolutions(cls):
        return Angle('rev', 360.0)
