# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty
import math


class Area(Unit):
    def __init__(self, symbol, coefficient):
        super(Area, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Area'

    @classmethod
    def base_unit(cls):
        return cls.square_meters

    @classproperty
    def square_megameters(cls):
        return Area('Mm²', 1e12)

    @classproperty
    def square_kilometers(cls):
        return Area('km²', 1e6)

    @classproperty
    def square_meters(cls):
        return Area('m²', 1.0)

    @classproperty
    def square_centimeters(cls):
        return Area('cm²', 1e-4)

    @classproperty
    def square_millimeters(cls):
        return Area('mm²', 1e-6)

    @classproperty
    def square_micrometers(cls):
        return Area('µm²', 1e-12)

    @classproperty
    def square_nanometers(cls):
        return Area('nm²', 1e-18)

    @classproperty
    def square_inches(cls):
        return Area('in²', 0.00064516)

    @classproperty
    def square_feet(cls):
        return Area('ft²', 0.092903)

    @classproperty
    def square_yards(cls):
        return Area('yd²', 0.836127)

    @classproperty
    def square_miles(cls):
        return Area('mi²', 2.59e+6)

    @classproperty
    def acres(cls):
        return Area('ac', 4046.86)

    @classproperty
    def ares(cls):
        return Area('a', 100.0)

    @classproperty
    def hectares(cls):
        return Area('ha', 10000.0)
