# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class ConcentrationMass(Unit):
    def __init__(self, symbol, coefficient):
        super(ConcentrationMass, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Concentration Mass'

    @classmethod
    def base_unit(cls):
        return cls.grams_per_liter

    @classproperty
    def grams_per_liter(cls):
        return ConcentrationMass('g/L', 1.0)

    @classproperty
    def milligrams_per_deciliter(cls):
        return ConcentrationMass('mg/dL', 0.01)

    @classproperty
    def millimoles_per_liter(cls):
        return ConcentrationMass('mmol/L', 18.0)

