# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Dispersion(Unit):
    def __init__(self, symbol, coefficient):
        super(Dispersion, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Dispersion'

    @classmethod
    def base_unit(cls):
        return cls.parts_per_million


    @classproperty
    def parts_per_million(cls):
        return Dispersion('ppm', 1.0)

