# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Duration(Unit):
    def __init__(self, symbol, coefficient):
        super(Duration, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Duration'

    @classmethod
    def base_unit(cls):
        return cls.seconds

    @classproperty
    def seconds(cls):
        return Duration('s', 1.0)

    @classproperty
    def minutes(cls):
        return Duration('m', 60.0)

    @classproperty
    def hours(cls):
        return Duration('h', 3600.0)

