# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class ElectricCharge(Unit):
    def __init__(self, symbol, coefficient):
        super(ElectricCharge, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Electric Charge'

    @classmethod
    def base_unit(cls):
        return cls.coulombs

    @classproperty
    def coulombs(cls):
        return ElectricCharge('C', 1.0)

    @classproperty
    def megaampere_hours(cls):
        return ElectricCharge('MAh', 3.6e9)

    @classproperty
    def kiloampere_hours(cls):
        return ElectricCharge('kAh', 3600000.0)

    @classproperty
    def ampere_hours(cls):
        return ElectricCharge('Ah', 3600.0)

    @classproperty
    def milliampere_hours(cls):
        return ElectricCharge('mAh', 3.6)

    @classproperty
    def microampere_hours(cls):
        return ElectricCharge('µAh', 0.0036)


