# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class ElectricCurrent(Unit):
    def __init__(self, symbol, coefficient):
        super(ElectricCurrent, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Electric Current'

    @classmethod
    def base_unit(cls):
        return cls.amperes


    @classproperty
    def megaamperes(cls):
        return ElectricCurrent('MA', 1e6)

    @classproperty
    def kiloamperes(cls):
        return ElectricCurrent('kA', 1e3)

    @classproperty
    def amperes(cls):
        return ElectricCurrent('A', 1.0)

    @classproperty
    def milliamperes(cls):
        return ElectricCurrent('mA', 1e-3)

    @classproperty
    def microamperes(cls):
        return ElectricCurrent('µA', 1e-6)