# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class ElectricPotentialDifference(Unit):
    def __init__(self, symbol, coefficient):
        super(ElectricPotentialDifference, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Electric Potential Difference'

    @classmethod
    def base_unit(cls):
        return cls.volts

    @classproperty
    def megavolts(cls):
        return ElectricPotentialDifference('MV', 1e6)

    @classproperty
    def kilovolts(cls):
        return ElectricPotentialDifference('kV', 1e3)

    @classproperty
    def volts(cls):
        return ElectricPotentialDifference('V', 1.0)

    @classproperty
    def millivolts(cls):
        return ElectricPotentialDifference('mV', 1e-3)

    @classproperty
    def microvolts(cls):
        return ElectricPotentialDifference('µV', 1e-6)
