# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class ElectricResistance(Unit):
    def __init__(self, symbol, coefficient):
        super(ElectricResistance, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Electric Resistance'

    @classmethod
    def base_unit(cls):
        return cls.ohms


    @classproperty
    def megaohms(cls):
        return ElectricResistance('MΩ', 1e6)

    @classproperty
    def kiloohms(cls):
        return ElectricResistance('kΩ', 1e3)

    @classproperty
    def ohms(cls):
        return ElectricResistance('Ω', 1.0)

    @classproperty
    def milliohms(cls):
        return ElectricResistance('mΩ', 1e-3)

    @classproperty
    def microohms(cls):
        return ElectricResistance('µΩ', 1e-6)

