# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Energy(Unit):
    def __init__(self, symbol, coefficient):
        super(Energy, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Energy'

    @classmethod
    def base_unit(cls):
        return cls.joules


    @classproperty
    def kilojoules(cls):
        return Energy('kJ', 1e3)

    @classproperty
    def joules(cls):
        return Energy('J', 1.0)

    @classproperty
    def kilocalories(cls):
        return Energy('kCal', 4184.0)

    @classproperty
    def calories(cls):
        return Energy('cal', 4.184)

    @classproperty
    def kilowattHours(cls):
        return Energy('kWh', 3600000.0)
