# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Frequency(Unit):
    def __init__(self, symbol, coefficient):
        super(Frequency, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Frequency'

    @classmethod
    def base_unit(cls):
        return cls.hertz


    @classproperty
    def terahertz(cls):
        return Frequency('THz', 1e12)

    @classproperty
    def gigahertz(cls):
        return Frequency('GHz', 1e9)

    @classproperty
    def megahertz(cls):
        return Frequency('MHz', 1e6)

    @classproperty
    def kilohertz(cls):
        return Frequency('kHz', 1e3)

    @classproperty
    def hertz(cls):
        return Frequency('Hz', 1.0)

    @classproperty
    def millihertz(cls):
        return Frequency('mHz', 1e-3)

    @classproperty
    def microhertz(cls):
        return Frequency('µHz', 1e-6)

    @classproperty
    def nanohertz(cls):
        return Frequency('nHz', 1e-9)
