# coding=utf-8
from aegon import Unit, UnitConverterReciprocal
from aegon.utils import classproperty


class FuelEfficiency(Unit):
    def __init__(self, symbol, reciporal):
        super(FuelEfficiency, self).__init__(symbol, UnitConverterReciprocal(reciporal))

    @classmethod
    def unit_name(cls):
        return 'Fuel Efficiency'

    @classmethod
    def base_unit(cls):
        return cls.liters_per_100_kilometers


    @classproperty
    def liters_per_100_kilometers(cls):
        return FuelEfficiency('L/100km', 1.0)

    @classproperty
    def miles_per_imperial_gallon(cls):
        return FuelEfficiency('mpg', 282.481)

    @classproperty
    def miles_per_gallon(cls):
        return FuelEfficiency('mpg', 235.215)
