# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Illuminance(Unit):
    def __init__(self, symbol, coefficient):
        super(Illuminance, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Illuminance'

    @classmethod
    def base_unit(cls):
        return cls.lux


    @classproperty
    def lux(cls):
        return Illuminance('lx', 1.0)

