# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Mass(Unit):
    def __init__(self, symbol, coefficient):
        super(Mass, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Mass'

    @classmethod
    def base_unit(cls):
        return cls.kilograms


    @classproperty
    def kilograms(cls):
        return Mass('kg', 1.0)

    @classproperty
    def grams(cls):
        return Mass('g', 1e-3)

    @classproperty
    def decigrams(cls):
        return Mass('dg', 1e-4)

    @classproperty
    def centigrams(cls):
        return Mass('cg', 1e-5)

    @classproperty
    def milligrams(cls):
        return Mass('mg', 1e-6)

    @classproperty
    def micrograms(cls):
        return Mass('µg', 1e-9)

    @classproperty
    def nanograms(cls):
        return Mass('ng', 1e-12)

    @classproperty
    def picograms(cls):
        return Mass('pg', 1e-15)

    @classproperty
    def ounces(cls):
        return Mass('oz', 0.0283495)

    @classproperty
    def pounds(cls):
        return Mass('lb', 0.453592)

    @classproperty
    def stones(cls):
        return Mass('st', 0.157473)

    @classproperty
    def metric_tons(cls):
        return Mass('t', 1000.0)

    @classproperty
    def short_tons(cls):
        return Mass('ton', 907.185)

    @classproperty
    def carats(cls):
        return Mass('ct', 0.0002)

    @classproperty
    def ounces_troy(cls):
        return Mass('oz t', 0.03110348)

    @classproperty
    def slugs(cls):
        return Mass('slug', 14.5939)

