# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Power(Unit):
    def __init__(self, symbol, coefficient):
        super(Power, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Power'

    @classmethod
    def base_unit(cls):
        return cls.watts


    @classproperty
    def terawatts(cls):
        return Power('TW', 1e12)

    @classproperty
    def gigawatts(cls):
        return Power('GW', 1e9)

    @classproperty
    def megawatts(cls):
        return Power('MW', 1e6)

    @classproperty
    def kilowatts(cls):
        return Power('kW', 1e3)

    @classproperty
    def watts(cls):
        return Power('W', 1.0)

    @classproperty
    def milliwatts(cls):
        return Power('mW', 1e-3)

    @classproperty
    def microwatts(cls):
        return Power('µW', 1e-6)

    @classproperty
    def nanowatts(cls):
        return Power('nW', 1e-9)

    @classproperty
    def picowatts(cls):
        return Power('nW', 1e-12)

    @classproperty
    def femtowatts(cls):
        return Power('nHz', 1e-15)

    @classproperty
    def horsepower(cls):
        return Power('hp', 745.7)

