from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty

class Speed(Unit):
    def __init__(self, symbol, coefficient):
        super(Speed, self).__init__(symbol, UnitConverterLinear(coefficient))

    @classmethod
    def unit_name(cls):
        return 'Speed'

    @classmethod
    def base_unit(cls):
        return cls.meters_per_second

    @classproperty
    def meters_per_second(cls):
        return Speed('m/s', 1.0)

    @classproperty
    def kilometers_per_hour(cls):
        return Speed('km/h', 0.277778)

    @classproperty
    def miles_per_hour(cls):
        return Speed('mph', 0.44704)

    @classproperty
    def knots(cls):
        return Speed('kn', 0.514444)
