# coding=utf-8
from aegon import Unit, UnitConverterLinear
from aegon.utils import classproperty


class Temperature(Unit):
    def __init__(self, symbol, coefficient, constant = 0.0):
        super(Temperature, self).__init__(symbol, UnitConverterLinear(coefficient, constant))

    @classmethod
    def unit_name(cls):
        return 'Temperature'

    @classmethod
    def base_unit(cls):
        return cls.kelvin

    @classproperty
    def kelvin(cls):
        return Temperature('K', 1.0)

    @classproperty
    def celsius(cls):
        return Temperature('°C', 1.0, constant=273.15)

    @classproperty
    def fahrenheit(cls):
        return Temperature('°F', 0.55555555555556, constant=255.37222222222427)
